/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWinFast.h"
#include <stdio.h>



PBFUNCTION(RGNDATA*) PB_LoadFastSkin(char *filename) {
   RGNDATA  *retval=0;

   if(filename) {
      FILE     *f;
      size_t    size;
      _sw_DKPS *skin;
      
      // open file
      if(f = fopen(filename,"rb")) {
         // go to end of file
         if(!fseek(f,0,SEEK_END)) {
            // get current position (size of file)
            if(size = ftell(f)) {
            	// filesize has to be greater than skin header
            	if(size>sizeof(_sw_DKPS)) {
                  // go back to start
                  rewind(f);
  
                  // alloc memory
                  if(skin = PB_AllocateMemory(size)) {
               	   // read file into memory
                     fread((void*)skin,size,1,f);
                     // catch skin from memory
                     retval = PB_CatchFastSkin(skin);
                     // free memory
                     PB_FreeMemory(skin);
                  }
               }
            }
         }
         // close file
         fclose(f);
      }
   }
   return retval;
}

